import{s as St,n as Ut,o as Ft}from"../chunks/scheduler.c57aa7ef.js";import{S as Gt,i as Rt,g as s,s as o,r as f,A as Bt,h as r,f as e,c as i,j as P,u,x as c,k as w,y as n,a as p,v as h,d as b,t as _,w as v}from"../chunks/index.394f8801.js";import{D as Q}from"../chunks/Docstring.46378b0f.js";import{H as kt,E as Jt}from"../chunks/EditOnGithub.157fddbf.js";function Kt(Et){let C,Y,W,Z,k,tt,E,Lt='<a href="https://huggingface.co/papers/2410.17222" rel="nofollow">Context-aware Prompt Tuning: Advancing In-Context Learning with Adversarial Methods (CPT)</a> combines In-Context Learning (ICL) with Prompt Tuning (PT) and adversarial optimization to improve few-shot learning by refining context embeddings. CPT optimizes only context tokens, which minimizes overfitting and enhances performance on classification tasks.',et,L,Ot="The abstract from the paper is:",nt,O,Nt="<em>Traditional fine-tuning is effective but computationally intensive, as it requires updating billions of parameters. CPT, inspired by ICL, PT, and adversarial attacks, refines context embeddings in a parameter-efficient manner. By optimizing context tokens and applying a controlled gradient descent, CPT achieves superior accuracy across various few-shot classification tasks, showing significant improvement over existing methods such as LoRA, PT, and ICL.</em>",at,N,ot,m,I,ft,V,It="CPT Configuration class extending PeftConfig for Context-aware Prompt Tuning (CPT).",ut,S,Mt="This class introduces additional parameters required for CPT, such as:",ht,U,jt="<li>Token type masks</li> <li>Prompt tuning initialization</li> <li>Loss weighting</li> <li>Projection settings</li>",bt,F,Dt='For more details, see the paper: <a href="https://arxiv.org/abs/2410.17222" rel="nofollow">https://arxiv.org/abs/2410.17222</a>',it,M,st,l,j,_t,G,zt=`CPTEmbedding is a custom embedding layer designed for Context-aware Prompt Tuning (CPT) in PEFT. It initializes
embeddings, applies prompt-specific projections, and computes loss using label masks.`,vt,$,D,Ct,R,Ht="Computes the loss for CPT models with optional exponential decay.",$t,T,z,Tt,B,At="Computes the prompt embeddings and applies delta adjustments.",xt,x,H,yt,J,qt="Applies epsilon-based projection to the delta embeddings to control their norm.",Pt,y,A,wt,K,Vt="Sets up a backward hook to selectively update token gradients based on the CPT token type mask.",rt,q,pt,X,lt;return k=new kt({props:{title:"Context-Aware Prompt Tuning (CPT)",local:"context-aware-prompt-tuning-cpt",headingTag:"h1"}}),N=new kt({props:{title:"CPTConfig",local:"peft.CPTConfig",headingTag:"h2"}}),I=new Q({props:{name:"class peft.CPTConfig",anchor:"peft.CPTConfig",parameters:[{name:"task_type",val:": typing.Union[str, peft.utils.peft_types.TaskType, NoneType] = None"},{name:"peft_type",val:": typing.Union[str, peft.utils.peft_types.PeftType, NoneType] = None"},{name:"auto_mapping",val:": typing.Optional[dict] = None"},{name:"base_model_name_or_path",val:": typing.Optional[str] = None"},{name:"revision",val:": typing.Optional[str] = None"},{name:"inference_mode",val:": bool = False"},{name:"num_virtual_tokens",val:": int = None"},{name:"token_dim",val:": int = None"},{name:"num_transformer_submodules",val:": typing.Optional[int] = None"},{name:"num_attention_heads",val:": typing.Optional[int] = None"},{name:"num_layers",val:": typing.Optional[int] = None"},{name:"cpt_token_ids",val:": typing.Optional[list[int]] = None"},{name:"cpt_mask",val:": typing.Optional[list[int]] = None"},{name:"cpt_tokens_type_mask",val:": typing.Optional[list[int]] = None"},{name:"opt_weighted_loss_type",val:": typing.Optional[typing.Literal['none', 'decay']] = 'none'"},{name:"opt_loss_decay_factor",val:": typing.Optional[float] = 1.0"},{name:"opt_projection_epsilon",val:": typing.Optional[float] = 0.1"},{name:"opt_projection_format_epsilon",val:": typing.Optional[float] = 0.1"},{name:"tokenizer_name_or_path",val:": typing.Optional[str] = None"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/cpt/config.py#L22"}}),M=new kt({props:{title:"CPTEmbedding",local:"peft.CPTEmbedding",headingTag:"h2"}}),j=new Q({props:{name:"class peft.CPTEmbedding",anchor:"peft.CPTEmbedding",parameters:[{name:"config",val:""},{name:"word_embeddings",val:""}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/cpt/model.py#L23"}}),D=new Q({props:{name:"calculate_loss",anchor:"peft.CPTEmbedding.calculate_loss",parameters:[{name:"base_model_output",val:""},{name:"labels",val:""},{name:"cpt_type_mask",val:""},{name:"config",val:""}],parametersDescription:[{anchor:"peft.CPTEmbedding.calculate_loss.base_model_output",description:`<strong>base_model_output</strong> (ModelOutput) &#x2014;
Output from the base model containing logits.`,name:"base_model_output"},{anchor:"peft.CPTEmbedding.calculate_loss.labels",description:`<strong>labels</strong> (torch.Tensor) &#x2014;
Ground-truth labels for the input tokens.`,name:"labels"},{anchor:"peft.CPTEmbedding.calculate_loss.cpt_type_mask",description:`<strong>cpt_type_mask</strong> (torch.Tensor) &#x2014;
Token type mask used for filtering valid loss terms.`,name:"cpt_type_mask"},{anchor:"peft.CPTEmbedding.calculate_loss.config",description:`<strong>config</strong> (Namespace) &#x2014;
Configuration object containing loss-related hyperparameters.`,name:"config"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/cpt/model.py#L141",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The base model output with computed loss.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>ModelOutput</p>
`}}),z=new Q({props:{name:"forward",anchor:"peft.CPTEmbedding.forward",parameters:[{name:"indices",val:""}],parametersDescription:[{anchor:"peft.CPTEmbedding.forward.indices",description:`<strong>indices</strong> (torch.Tensor) &#x2014;
Indices of the tokens to be embedded.`,name:"indices"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/cpt/model.py#L63",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Sum of prompt embeddings and delta embeddings.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>torch.Tensor</p>
`}}),H=new Q({props:{name:"get_projection",anchor:"peft.CPTEmbedding.get_projection",parameters:[],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/cpt/model.py#L123"}}),A=new Q({props:{name:"set_updated_tokens",anchor:"peft.CPTEmbedding.set_updated_tokens",parameters:[],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/cpt/model.py#L84"}}),q=new Jt({props:{source:"https://github.com/huggingface/peft/blob/main/docs/source/package_reference/cpt.md"}}),{c(){C=s("meta"),Y=o(),W=s("p"),Z=o(),f(k.$$.fragment),tt=o(),E=s("p"),E.innerHTML=Lt,et=o(),L=s("p"),L.textContent=Ot,nt=o(),O=s("p"),O.innerHTML=Nt,at=o(),f(N.$$.fragment),ot=o(),m=s("div"),f(I.$$.fragment),ft=o(),V=s("p"),V.textContent=It,ut=o(),S=s("p"),S.textContent=Mt,ht=o(),U=s("ul"),U.innerHTML=jt,bt=o(),F=s("p"),F.innerHTML=Dt,it=o(),f(M.$$.fragment),st=o(),l=s("div"),f(j.$$.fragment),_t=o(),G=s("p"),G.textContent=zt,vt=o(),$=s("div"),f(D.$$.fragment),Ct=o(),R=s("p"),R.textContent=Ht,$t=o(),T=s("div"),f(z.$$.fragment),Tt=o(),B=s("p"),B.textContent=At,xt=o(),x=s("div"),f(H.$$.fragment),yt=o(),J=s("p"),J.textContent=qt,Pt=o(),y=s("div"),f(A.$$.fragment),wt=o(),K=s("p"),K.textContent=Vt,rt=o(),f(q.$$.fragment),pt=o(),X=s("p"),this.h()},l(t){const a=Bt("svelte-u9bgzb",document.head);C=r(a,"META",{name:!0,content:!0}),a.forEach(e),Y=i(t),W=r(t,"P",{}),P(W).forEach(e),Z=i(t),u(k.$$.fragment,t),tt=i(t),E=r(t,"P",{"data-svelte-h":!0}),c(E)!=="svelte-ho523"&&(E.innerHTML=Lt),et=i(t),L=r(t,"P",{"data-svelte-h":!0}),c(L)!=="svelte-1cwsb16"&&(L.textContent=Ot),nt=i(t),O=r(t,"P",{"data-svelte-h":!0}),c(O)!=="svelte-sh1gsw"&&(O.innerHTML=Nt),at=i(t),u(N.$$.fragment,t),ot=i(t),m=r(t,"DIV",{class:!0});var g=P(m);u(I.$$.fragment,g),ft=i(g),V=r(g,"P",{"data-svelte-h":!0}),c(V)!=="svelte-pvpmqk"&&(V.textContent=It),ut=i(g),S=r(g,"P",{"data-svelte-h":!0}),c(S)!=="svelte-jwcs2b"&&(S.textContent=Mt),ht=i(g),U=r(g,"UL",{"data-svelte-h":!0}),c(U)!=="svelte-aqudvo"&&(U.innerHTML=jt),bt=i(g),F=r(g,"P",{"data-svelte-h":!0}),c(F)!=="svelte-1hxqr0v"&&(F.innerHTML=Dt),g.forEach(e),it=i(t),u(M.$$.fragment,t),st=i(t),l=r(t,"DIV",{class:!0});var d=P(l);u(j.$$.fragment,d),_t=i(d),G=r(d,"P",{"data-svelte-h":!0}),c(G)!=="svelte-1cdhmyj"&&(G.textContent=zt),vt=i(d),$=r(d,"DIV",{class:!0});var mt=P($);u(D.$$.fragment,mt),Ct=i(mt),R=r(mt,"P",{"data-svelte-h":!0}),c(R)!=="svelte-9bizft"&&(R.textContent=Ht),mt.forEach(e),$t=i(d),T=r(d,"DIV",{class:!0});var dt=P(T);u(z.$$.fragment,dt),Tt=i(dt),B=r(dt,"P",{"data-svelte-h":!0}),c(B)!=="svelte-3v5t0c"&&(B.textContent=At),dt.forEach(e),xt=i(d),x=r(d,"DIV",{class:!0});var ct=P(x);u(H.$$.fragment,ct),yt=i(ct),J=r(ct,"P",{"data-svelte-h":!0}),c(J)!=="svelte-pg5azd"&&(J.textContent=qt),ct.forEach(e),Pt=i(d),y=r(d,"DIV",{class:!0});var gt=P(y);u(A.$$.fragment,gt),wt=i(gt),K=r(gt,"P",{"data-svelte-h":!0}),c(K)!=="svelte-1bcpx1v"&&(K.textContent=Vt),gt.forEach(e),d.forEach(e),rt=i(t),u(q.$$.fragment,t),pt=i(t),X=r(t,"P",{}),P(X).forEach(e),this.h()},h(){w(C,"name","hf:doc:metadata"),w(C,"content",Qt),w(m,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(l,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,a){n(document.head,C),p(t,Y,a),p(t,W,a),p(t,Z,a),h(k,t,a),p(t,tt,a),p(t,E,a),p(t,et,a),p(t,L,a),p(t,nt,a),p(t,O,a),p(t,at,a),h(N,t,a),p(t,ot,a),p(t,m,a),h(I,m,null),n(m,ft),n(m,V),n(m,ut),n(m,S),n(m,ht),n(m,U),n(m,bt),n(m,F),p(t,it,a),h(M,t,a),p(t,st,a),p(t,l,a),h(j,l,null),n(l,_t),n(l,G),n(l,vt),n(l,$),h(D,$,null),n($,Ct),n($,R),n(l,$t),n(l,T),h(z,T,null),n(T,Tt),n(T,B),n(l,xt),n(l,x),h(H,x,null),n(x,yt),n(x,J),n(l,Pt),n(l,y),h(A,y,null),n(y,wt),n(y,K),p(t,rt,a),h(q,t,a),p(t,pt,a),p(t,X,a),lt=!0},p:Ut,i(t){lt||(b(k.$$.fragment,t),b(N.$$.fragment,t),b(I.$$.fragment,t),b(M.$$.fragment,t),b(j.$$.fragment,t),b(D.$$.fragment,t),b(z.$$.fragment,t),b(H.$$.fragment,t),b(A.$$.fragment,t),b(q.$$.fragment,t),lt=!0)},o(t){_(k.$$.fragment,t),_(N.$$.fragment,t),_(I.$$.fragment,t),_(M.$$.fragment,t),_(j.$$.fragment,t),_(D.$$.fragment,t),_(z.$$.fragment,t),_(H.$$.fragment,t),_(A.$$.fragment,t),_(q.$$.fragment,t),lt=!1},d(t){t&&(e(Y),e(W),e(Z),e(tt),e(E),e(et),e(L),e(nt),e(O),e(at),e(ot),e(m),e(it),e(st),e(l),e(rt),e(pt),e(X)),e(C),v(k,t),v(N,t),v(I),v(M,t),v(j),v(D),v(z),v(H),v(A),v(q,t)}}}const Qt='{"title":"Context-Aware Prompt Tuning (CPT)","local":"context-aware-prompt-tuning-cpt","sections":[{"title":"CPTConfig","local":"peft.CPTConfig","sections":[],"depth":2},{"title":"CPTEmbedding","local":"peft.CPTEmbedding","sections":[],"depth":2}],"depth":1}';function Wt(Et){return Ft(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ee extends Gt{constructor(C){super(),Rt(this,C,Wt,Kt,St,{})}}export{ee as component};
